#include <Xm/Xm.h>
#include <iostream.h>
#include <unistd.h>
#include "global.h"
#include "messages.h"

void r_cb(Widget widget, XtPointer client_data, XtPointer call_data) {
  int item, i, j, is_valid;

  extern void showmess(Widget widget, char *title, char *text);

  item=(int) client_data;
  switch(item) {
  case 0:  // start stimulation;
    /* Plausibility checking */
    is_valid=1;
    /* one channel must be active */
    j=0;
    for (i=0; i<8; i++) if (msg.is_active[i]) j++;
    if (!j) {
      showmess(main_w, NO_ACTIVE_CHANNELS_H, NO_ACTIVE_CHANNELS_T);
      is_valid=0;
    }
    /* Train Duration longer than Train Period */
    j=1;
    for (i=0; i<8; i++) if (msg.train_d[i]>msg.train_l[i]) j=0;
    if (!j) {
      showmess(main_w, TRAIN_TIMING_H, TRAIN_TIMING_T);
      is_valid=0;
    }
    /* Pulse Duration longer than Pulse Period */
    j=1;
    for (i=0; i<8; i++) if (msg.pulse_d[i]>msg.pulse_l[i]) j=0;
    if (!j) {
      showmess(main_w, PULSE_TIMING_H, PULSE_TIMING_T);
      is_valid=0;
    }
    /* Pulse longer than Train */
    j=1;
    for (i=0; i<8; i++) if (msg.pulse_l[i]>msg.train_l[i]) j=0;
    if (!j) {
      showmess(main_w, PULSE_TRAIN_RATIO_H, PULSE_TRAIN_RATIO_T);
      is_valid=0;
    }
    /* Pulse periode longer than train duration */
    j=1;
    for (i=0; i<8; i++) if (msg.pulse_l[i]>msg.train_d[i]) j=0;
    if (!j) {
      showmess(main_w, PULSE_TRAIN_RATIO2_H, PULSE_TRAIN_RATIO2_T);
      is_valid=0;
    }

    /* now start the stimulator */
    if (!is_running && is_valid) {
      is_running=1;
      XtVaSetValues(stim_label, XmNlabelString, XmStringCreateLocalized("running"), NULL);
      XtSetSensitive(mymenu.run.e_run,True);
      XtSetSensitive(mymenu.run.s_run,False);
      XtSetSensitive(mymenu.file.l_setup,False);
      XtSetSensitive(mymenu.file.s_setup,False);
      XtSetSensitive(mymenu.file.quit,False);
      msg.command=START_TASK;
      write(fd, &msg, sizeof(msg));
    }
    break;
  case 1:  // stop stimulation;
    if (is_running) {
      is_running=0;
      XtVaSetValues(stim_label, XmNlabelString, XmStringCreateLocalized("not running"), NULL);
      XtSetSensitive(mymenu.run.e_run,False);
      XtSetSensitive(mymenu.run.s_run,True);
      XtSetSensitive(mymenu.file.l_setup,True);
      XtSetSensitive(mymenu.file.s_setup,True);
      XtSetSensitive(mymenu.file.quit,True);
      msg.command=STOP_TASK;
      write(fd, &msg, sizeof(msg));
    }
    break;
  }
}
